# std::indirect_array< Type > Class Template Reference

Reference to arbitrary subset of an array. More...

`#include <indirect_array.h>`

List of all members.

## Public Member Functions

| indirect_array (const indirect_array &)
| Copy constructor. Both slices refer to the same underlying array.
indirect_array & | operator= (const indirect_array &)
| Assignment operator. Assigns elements to corresponding elements of a.
void | operator= (const valarray< Type > &) const
| Assign slice elements to corresponding elements of v.
void | operator *= (const valarray< Type > &) const
| Multiply slice elements by corresponding elements of v.
void | operator/= (const valarray< Type > &) const
| Divide slice elements by corresponding elements of v.
void | operator%= (const valarray< Type > &) const
| Modulo slice elements by corresponding elements of v.
void | operator+= (const valarray< Type > &) const
| Add corresponding elements of v to slice elements.
void | operator-= (const valarray< Type > &) const
| Subtract corresponding elements of v from slice elements.
void | operator^= (const valarray< Type > &) const
| Logical xor slice elements with corresponding elements of v.
void | operator &= (const valarray< Type > &) const
| Logical and slice elements with corresponding elements of v.
void | operator|= (const valarray< Type > &) const
| Logical or slice elements with corresponding elements of v.
void | operator<<= (const valarray< Type > &) const
| Left shift slice elements by corresponding elements of v.
void | operator>>= (const valarray< Type > &) const
| Right shift slice elements by corresponding elements of v.
void | operator= (const Type &) const
| Assign all slice elements to t.

## Private Member Functions

| indirect_array (Array< Type >, size_t, Array< size_t >)
| Copy constructor. Both slices refer to the same underlying array.

## Detailed Description

### template<class Type>
class std::indirect_array< Type >

Reference to arbitrary subset of an array.

An indirect_array is a reference to the actual elements of an array specified by an ordered array of indices. The way to get an indirect_array is to call operator[](valarray<size_t>) on a valarray. The returned indirect_array then permits carrying operations out on the referenced subset of elements in the original valarray.

For example, if an indirect_array is obtained using the array (4,2,0) as an argument, and then assigned to an array containing (1,2,3), then the underlying array will have array[0]==3, array[2]==2, and array[4]==1.

Parameters:

  | Tp | Element type.

Definition at line 61 of file indirect_array.h.

## Constructor & Destructor Documentation

template<typename Type>
std::indirect_array< Type >::indirect_array | ( | const indirect_array< Type > & |  | ) | `[inline]`

| Copy constructor. Both slices refer to the same underlying array. Definition at line 142 of file indirect_array.h.

template<typename Type>
std::indirect_array< Type >::indirect_array | ( | Array< Type > | ,
|  | size_t | ,
|  | Array< size_t > |
| ) | `[inline, private]`

| Copy constructor. Both slices refer to the same underlying array. Definition at line 147 of file indirect_array.h.

## Member Function Documentation

template<class Type>
void std::indirect_array< Type >::operator &= | ( | const valarray< Type > & |  | ) | const

| Logical and slice elements with corresponding elements of v.

template<class Type>
void std::indirect_array< Type >::operator *= | ( | const valarray< Type > & |  | ) | const

| Multiply slice elements by corresponding elements of v.

template<class Type>
void std::indirect_array< Type >::operator%= | ( | const valarray< Type > & |  | ) | const

| Modulo slice elements by corresponding elements of v.

template<class Type>
void std::indirect_array< Type >::operator+= | ( | const valarray< Type > & |  | ) | const

| Add corresponding elements of v to slice elements.

template<class Type>
void std::indirect_array< Type >::operator-= | ( | const valarray< Type > & |  | ) | const

| Subtract corresponding elements of v from slice elements.

template<class Type>
void std::indirect_array< Type >::operator/= | ( | const valarray< Type > & |  | ) | const

| Divide slice elements by corresponding elements of v.

template<class Type>
void std::indirect_array< Type >::operator<<= | ( | const valarray< Type > & |  | ) | const

| Left shift slice elements by corresponding elements of v.

template<typename Type>
void std::indirect_array< Type >::operator= | ( | const Type & |  | ) | const`[inline]`

| Assign all slice elements to t. Definition at line 162 of file indirect_array.h.

template<typename Type>
void std::indirect_array< Type >::operator= | ( | const valarray< Type > & |  | ) | const`[inline]`

| Assign slice elements to corresponding elements of v. Definition at line 167 of file indirect_array.h.

template<typename Type>
indirect_array< Type > & std::indirect_array< Type >::operator= | ( | const indirect_array< Type > & |  | ) | `[inline]`

| Assignment operator. Assigns elements to corresponding elements of a. Definition at line 153 of file indirect_array.h.

template<class Type>
void std::indirect_array< Type >::operator>>= | ( | const valarray< Type > & |  | ) | const

| Right shift slice elements by corresponding elements of v.

template<class Type>
void std::indirect_array< Type >::operator^= | ( | const valarray< Type > & |  | ) | const

| Logical xor slice elements with corresponding elements of v.

template<class Type>
void std::indirect_array< Type >::operator|= | ( | const valarray< Type > & |  | ) | const

| Logical or slice elements with corresponding elements of v.

The documentation for this class was generated from the following file:

- indirect_array.h